summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-07-26 11:27:56 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-07-27 00:31:53 +0000
commit5323d07b2ce9416e5958be415c35220cce3b4114 (patch)
tree60ad17be121c5473857d8ff9f22bb384211df5bc
parentCorrecting synopsis in container-run manpage. (diff)
downloadcompute-tools-5323d07b2ce9416e5958be415c35220cce3b4114.tar.xz
compute-tools-5323d07b2ce9416e5958be415c35220cce3b4114.zip
Adding container update command.
Signed-off-by: Daniel Baumann <daniel.baumann@open-infrastructure.net>
-rw-r--r--Makefile1
-rwxr-xr-xbin/container2
-rwxr-xr-xlibexec/container/update143
-rw-r--r--share/bash-completion/container16
-rw-r--r--share/man/container-update.1.rst111
-rw-r--r--share/man/container.1.rst3
6 files changed, 275 insertions, 1 deletions
diff --git a/Makefile b/Makefile
index 98dc791..a0e050d 100644
--- a/Makefile
+++ b/Makefile
@@ -133,6 +133,7 @@ install: build
ln -sf start $(DESTDIR)/usr/libexec/$(PROGRAM)/s
ln -sf status $(DESTDIR)/usr/libexec/$(PROGRAM)/st
ln -sf stop $(DESTDIR)/usr/libexec/$(PROGRAM)/t
+ ln -sf update $(DESTDIR)/usr/libexec/$(PROGRAM)/u
mkdir -p $(DESTDIR)/lib/systemd/system
cp -r share/systemd/* $(DESTDIR)/lib/systemd/system
diff --git a/bin/container b/bin/container
index e284c23..c4e2018 100755
--- a/bin/container
+++ b/bin/container
@@ -65,7 +65,7 @@ do
OPTIONS="$(echo "${OPTIONS}" | sed -e 's|--no-notification||')"
else
case "${COMMAND}" in
- build|b|move|mv|remove|rm|restart|rt|start|s|stop|t)
+ build|b|move|mv|remove|rm|restart|rt|start|s|stop|t|update|u)
if [ -z "${CONTAINER_USER}" ]
then
CONTAINER_USER="${SUDO_USER:-${USER}}"
diff --git a/libexec/container/update b/libexec/container/update
new file mode 100755
index 0000000..bb175d1
--- /dev/null
+++ b/libexec/container/update
@@ -0,0 +1,143 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2021 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+PROJECT="open-infrastructure"
+SOFTWARE="compute-tools"
+PROGRAM="container"
+COMMAND="$(basename ${0})"
+
+HOOKS="/etc/${SOFTWARE}/hooks"
+
+Parameters ()
+{
+ GETOPT_LONGOPTIONS="name:,full-upgrade,autoremove,purge,yes,"
+ GETOPT_OPTIONS="n:,r,p,y,"
+
+ PARAMETERS="$(getopt --longoptions ${GETOPT_LONGOPTIONS} --name=${COMMAND} --options ${GETOPT_OPTIONS} --shell sh -- ${@})"
+
+ if [ "${?}" != "0" ]
+ then
+ echo "'${COMMAND}': getopt exit" >&2
+ exit 1
+ fi
+
+ eval set -- "${PARAMETERS}"
+
+ while true
+ do
+ case "${1}" in
+ -n|--name)
+ NAME="${2}"
+ shift 2
+ ;;
+
+ -f|--full-upgrade)
+ FULL_UPGRADE="true"
+ shift 1
+ ;;
+
+ -r|--autoremove)
+ AUTOREMOVE="true"
+ shift 1
+ ;;
+
+ -p|--purge)
+ PURGE="--purge"
+ shift 1
+ ;;
+
+ -y|--yes)
+ YES="-y"
+ shift 1
+ ;;
+
+ --)
+ shift 1
+ break
+ ;;
+
+ *)
+ echo "'${COMMAND}': getopt error" >&2
+ exit 1
+ ;;
+ esac
+ done
+}
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} ${COMMAND} -n|--name NAME [-f|--full-upgrade] [-r|--autoremove] [-p|--purge] [-y|--yes]" >&2
+ exit 1
+}
+
+Parameters "${@}"
+
+case "${NAME}" in
+ ALL)
+ NAMES="$(container list --started --format shell)"
+ ;;
+
+ *)
+ NAMES="${NAME}"
+ ;;
+esac
+
+# Pre hooks
+for FILE in "${HOOKS}/pre-${COMMAND}".* "${HOOKS}/${NAME}.pre-${COMMAND}"
+do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+done
+
+# Run
+for NAME in ${NAMES}
+do
+ echo "################################################################################"
+ echo "Updating ${NAME}"
+ echo "################################################################################"
+
+ container run -n ${NAME} -- "apt update && apt ${YES} upgrade"
+
+ case "${FULL_UPGRADE}" in
+ true)
+ container run -n ${NAME} -- "apt update && ${YES} full-upgrade"
+ ;;
+ esac
+
+ case "${AUTOREMOVE}" in
+ true)
+ container run -n ${NAME} -- "apt ${YES} autoremove ${PURGE}"
+ ;;
+ esac
+
+ echo "'${NAME}': container updated."
+done
+
+# Post hooks
+for FILE in "${HOOKS}/post-${COMMAND}".* "${HOOKS}/${NAME}.post-${COMMAND}"
+do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+done
diff --git a/share/bash-completion/container b/share/bash-completion/container
index bb3eb41..dfb7ad5 100644
--- a/share/bash-completion/container
+++ b/share/bash-completion/container
@@ -334,6 +334,22 @@ _container()
return 0
;;
+ update|u)
+ case "${prev}" in
+ -n|--name)
+ opts="$(container list -s -f shell)"
+ COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
+ return 0
+ ;;
+
+ *)
+ opts="-n --name -y --yes"
+ COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
+ return 0
+ ;;
+ esac
+ ;;
+
version|ver)
return 0
;;
diff --git a/share/man/container-update.1.rst b/share/man/container-update.1.rst
new file mode 100644
index 0000000..7b17ae2
--- /dev/null
+++ b/share/man/container-update.1.rst
@@ -0,0 +1,111 @@
+.. Open Infrastructure: compute-tools
+
+.. Copyright (C) 2014-2021 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+..
+.. SPDX-License-Identifier: GPL-3.0+
+..
+.. This program is free software: you can redistribute it and/or modify
+.. it under the terms of the GNU General Public License as published by
+.. the Free Software Foundation, either version 3 of the License, or
+.. (at your option) any later version.
+..
+.. This program is distributed in the hope that it will be useful,
+.. but WITHOUT ANY WARRANTY; without even the implied warranty of
+.. MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+.. GNU General Public License for more details.
+..
+.. You should have received a copy of the GNU General Public License
+.. along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+================
+container-update
+================
+
+--------------------------------------------
+Update the packages installed in a container
+--------------------------------------------
+
+:manual section: 1
+:manual group: Open Infrastructure
+
+Synopsis
+========
+
+| **container update** ['OPTIONS']
+| **cnt u** ['OPTIONS']
+
+Description
+===========
+
+The **container update** command updates packages installed in a container.
+
+Options
+=======
+
+The following **container update** options are available:
+
+-n, --name='NAME':
+ Specify container name. Specifying 'ALL' will start all stopped container.
+
+-f, --full-upgrade:
+ Runs an additional 'apt full-upgrade' after 'apt upgrade'.
+
+-r, --autoremove:
+ Runs an additional 'apt autoremove' after 'apt upgrade'.
+
+-p, --purge:
+ Passing '--purge' to 'apt autoremove'.
+
+-y|--yes:
+ Passing 'yes' to all questions asked by the package manager.
+
+Examples
+========
+
+Update example.net container (apt update && apt upgrade):
+
+ sudo container update -n example.net
+
+Update example.net container without asking questions (apt update && apt --yes
+upgrade):
+
+ sudo container update -n example.net -y
+
+Full update of example.net container without asking questions (apt update &&
+apt --yes upgrade && apt --yes full-upgrade):
+
+ sudo container update -n example.net -f -y
+
+Full update of all container on the host, with asking questions and
+purging unused packages (apt update && apt upgrade && apt full-upgrade && apt
+autoremove):
+
+ sudo container update -n ALL -f -r -p -y
+
+See also
+========
+
+| compute-tools(7),
+| container(1).
+
+Homepage
+========
+
+More information about compute-tools and the Open Infrastructure project can be
+found on the homepage (https://open-infrastructure.net).
+
+Contact
+=======
+
+Bug reports, feature requests, help, patches, support and everything else are
+welcome on the Open Infrastructure Software Mailing List
+<software@lists.open-infrastructure.net>.
+
+Debian specific bugs can also be reported in the Debian Bug Tracking System
+(https://bugs.debian.org).
+
+Authors
+=======
+
+compute-tools were written by Daniel Baumann
+<daniel.baumann@open-infrastructure.net> and others.
diff --git a/share/man/container.1.rst b/share/man/container.1.rst
index cce283b..05139f5 100644
--- a/share/man/container.1.rst
+++ b/share/man/container.1.rst
@@ -101,6 +101,9 @@ status:
top:
Dynamic list of container on the system, see container-top(1).
+update:
+ Update the packages installed in a container.
+
version:
Show container version, see container-version(1).